from tonconsole.tonapi.async_tonapi import AsyncTonapiClient

from tonconsole.tonapi.schema.jettons import JettonInfo


class JettonMethod(AsyncTonapiClient):

    async def get_info(self, account_id: str) -> JettonInfo:
        """
        Get jetton metadata by jetton master address.

        :param account_id: account ID
        :return: :class:`JettonInfo`
        """
        method = f"v2/jettons/{account_id}"
        response = await self._request(method=method)

        return JettonInfo(**response)
